<?PHP
/*
Plugin Name: Flowplayer for Wordpress
Plugin URI: http://saiweb.co.uk
Description: Flowplayer Wordpress Extension GPL Edition
Version: 0.1
Author: David Busby
Author URI: http://saiweb.co.uk
*/
/**
 * FlowPlayer for Wordpress
 * ©2008 David Busby
 * @see http://creativecommons.org/licenses/by-nc-sa/2.0/uk
 */

add_filter('the_content', 'flowplayer_content');

function flowplayer_content( $content ) {
	$fp = new flowplayer();
	
	$regex = '/\[FLOWPLAYER=([a-z0-9\.\-\&\_]+)\,([0-9]+)\,([0-9]+)\]/';
	$matches = array();

	preg_match_all($regex, $content, $matches);
	
	if(count($matches) > 0) {
		foreach($matches[0] as $key => $data) {
			$content = str_replace($matches[0][$key], $fp->build_min_player($matches[2][$key], $matches[3][$key], $matches[1][$key]),$content);

		}
	
	}
	
	return $content;
}

class flowplayer
{
	private $count = 0;
	
	const RELATIVE_PATH = '/wp-content/plugins/word-press-flow-player/';
	const VIDEO_PATH = '/videos/';
	
	public function build_min_player($width, $height, $media) {
			$this->count++;
			
			$html = '';
			
			if($this->count == 1){
				$html = '<script type="text/javascript" src="'.flowplayer::RELATIVE_PATH.'js/flashembed.min.js"></script>';
			}
			
			$html .= '
			<script type="text/javascript">
	 /*
		use flashembed to place flowplayer into HTML element 
		whose id is "example" (below this script tag)
	 */
	 flashembed("media_'.$this->count.'", 
	
		/* 
			first argument supplies standard Flash parameters. See full list:
			http://kb.adobe.com/selfservice/viewContent.do?externalId=tn_12701
		*/
		{
			src:\''.flowplayer::RELATIVE_PATH .'FlowPlayerDark.swf\',
			width: '.$width.', 
			height: '.$height.'
		},
		
		/*
			second argument is Flowplayer specific configuration. See full list:
			http://flowplayer.org/player/configuration.html
		*/
		{config: {   
			autoPlay: false,
			autoBuffering: false,
			loop: false,
			controlBarBackgroundColor:\'0x007062\',
			initialScale: \'scale\',
			videoFile: \'http://'.$_SERVER['SERVER_NAME'].flowplayer::VIDEO_PATH.$media.'\'
		}}
		);
		</script>
		<div id="media_'.$this->count.'"></div>
	';
		return $html;
	}
}
?>